#include"RandomBox.h"

///<summary>ڽ  ̾ ڿ ȯմϴ.     ڿ ȯմϴ.</summary>
string RandomBox::Pick()
{
    random_device randomDevice;
    default_random_engine randomEngine(randomDevice());

    uniform_real_distribution<> randomRange(0.0f, 1.0f);

    // Ȯ ǥմϴ. 0~1̿ Ͽ,  üũ  پϴ. 0 Ǹ ش  ȯϰ մϴ.
    float rateLeft = randomRange(randomEngine);
    //εȮ  Ͽ شϴ  ִ Ȯմϴ.
    Content* result = nullptr;
    if (rootNonFlexible != nullptr)
    {
        result = rootNonFlexible->RateCheck(&rateLeft, 1.0f);
    };
    //شϴ   
    if (result != nullptr)
    {
        //  ̻    °   εȮ  Դϴ.
        if (!result->AvailableCheck())
        {
            rateNonFlexible -= result->GetRate();
        };
        // ̸ ȯմϴ.
        return result->GetName();
    }
    //شϴ    
    else
    {
        //Ȯ  ãϴ.
        //ü Ȯ  Ȯ Ͽ Ȯ մϴ.
        //)εȮ   Ȯ 0.5̰, Ȯ  1̶,  Ȯ  Ͽ  Ȯ ϴ.
        if (rootFlexible != nullptr)
        {
            result = rootFlexible->RateCheck(&rateLeft, (1.0f - rateNonFlexible) / rateFlexible);
        };

        //شϴ   
        if (result != nullptr)
        {
            //  ̻    °   Ȯ  Դϴ.
            if (!result->AvailableCheck())
            {
                rateFlexible -= result->GetRate();
            };

            // ̸ ȯմϴ.
            return result->GetName();
        }
        //شϴ  ٸ, nullptr ȯմϴ.
        else
        {
            return "";
        };
    };
}

///<summary>ϴ  ̸ ,      ȯմϴ.</summary>
ContentViewer RandomBox::GetViewer(string name)
{
    //ش  ãϴ.
    Content* origin = rootTrie->Find(name);

    //ش  ϸ  ,  nullptr ȯմϴ.
    if (origin != nullptr)
    {
        return origin->GetViewer();
    }
    else
    {
        return ContentViewer();
    };
}

///<summary>/εȮ   ִ  Ʈ ȯմϴ.</summary>
///<param name="wantFlexible">true , false εȮ Ÿϴ.</param>
vector<ContentViewer> RandomBox::GetViewerAll(bool wantFlexible)
{
    //Ȯ εȮ Ȯ Ŀ,   ɴϴ.
    if (wantFlexible)
    {
        if (rootFlexible != nullptr)
        {
            return rootFlexible->GetViewerAll();
        }
        else
        {
            return vector<ContentViewer>();
        };
    }
    else
    {
        if (rootNonFlexible != nullptr)
        {
            return rootNonFlexible->GetViewerAll();
        }
        else
        {
            return vector<ContentViewer>();
        };
    };
}

///<summary>ϴ ̸  մϴ.</summary>
void RandomBox::Delete(string name)
{
    //شϴ  ãϴ.
    Content* targetContent = rootTrie->Find(name);

    // ϴ 쿡 մϴ.
    if (targetContent != nullptr)
    {
        //Trie ڷᱸ ش ̸ մϴ.
        targetContent->inTrie->Delete();

        ///ε Ȯ Ȯ Ŀ, شϴ ġ ϰ Ȯ ٽ մϴ.
        if (targetContent->isFlexible)
        {
            rootFlexible = targetContent->Delete(rootFlexible);
            rateFlexible = rootFlexible->GetTotalRate();
        }
        else
        {
            rootNonFlexible = targetContent->Delete(rootNonFlexible);
            rateNonFlexible = rootNonFlexible->GetTotalRate();
        };
        free(targetContent);
    };
}

///<summary>ϴ  ̸, Ȯ, ɼ Ͽ մϴ.     ֽϴ.</summary>
bool RandomBox::Insert(string name, float wantRate, bool wantFlexible)
{
    //شϴ ̸  ִ Ȯմϴ.
    Content* targetItem = rootTrie->Find(name);

    // Ȯ  쿡 ο  մϴ.
    if (targetItem == nullptr)
    {
        targetItem = new Content(name, wantRate, wantFlexible);

        //ɼ Ȯϰ شϴ ο ֽϴ.
        // Ȯ ٽ մϴ.
        if (wantFlexible)
        {
            rootFlexible = targetItem->Insert(rootFlexible);
            rateFlexible = rootFlexible->GetTotalRate();
        }
        else
        {
            rootNonFlexible = targetItem->Insert(rootNonFlexible);
            rateNonFlexible = rootNonFlexible->GetTotalRate();
        };

        //Trie ڷᱸ ش ̸ ߰մϴ.
        rootTrie->Insert(name, targetItem);
        return true;
    }
    //̹ ִ ̸  ʽϴ.
    else
    {
        return false;
    };
}

///<summary>ϴ  ̸, Ȯ, , ɼ Ͽ մϴ.  ŭ   ֽϴ.</summary>
bool RandomBox::Insert(string name, float wantRate, unsigned int wantNumber, bool wantFlexible)
{
    //شϴ ̸  ִ Ȯմϴ.
    Content* targetItem = rootTrie->Find(name);

    // Ȯ  쿡 ο  մϴ.
    if (targetItem == nullptr)
    {
        targetItem = new Content(name, wantRate, wantNumber, wantFlexible);

        //ɼ Ȯϰ شϴ ο ֽϴ.
        // Ȯ ٽ մϴ.
        if (wantFlexible)
        {
            rootFlexible = targetItem->Insert(rootFlexible);
            rateFlexible = rootFlexible->GetTotalRate();
        }
        else
        {
            rootNonFlexible = targetItem->Insert(rootNonFlexible);
            rateNonFlexible = rootNonFlexible->GetTotalRate();
        };

        //Trie ڷᱸ ش ̸ ߰մϴ.
        rootTrie->Insert(name, targetItem);
        return true;
    }
    //̹ ִ ̸  ʽϴ.
    else
    {
        return false;
    };
}

///<summary>ϴ    ŵϴ.</summary>
void RandomBox::NumberAdd(string name, unsigned int wantNumber)
{
    //شϴ ̸  ִ Ȯմϴ.
    Content* targetContent = rootTrie->Find(name);

    //߰  ִ 
    if (targetContent != nullptr)
    {
        //   ִ ¿ Ȯմϴ.
        bool alreadyAvailable = targetContent->AvailableCheck();
        //  ߰մϴ.
        targetContent->AddNumber(wantNumber);

        //    ִ ° ƴϾ,  ߰   ְ  Ȳ̶
        //شϴ  Ȯտ  Ȯ մϴ.
        if (alreadyAvailable == false && targetContent->AvailableCheck())
        {
            if (targetContent->isFlexible)
            {
                rateFlexible += targetContent->GetRate();
            }
            else
            {
                rateNonFlexible += targetContent->GetRate();
            };
        };
    };
}

///<summary>ϴ    ҽŵϴ.</summary>
void RandomBox::NumberSub(string name, unsigned int wantNumber)
{
    //شϴ ̸  ִ Ȯմϴ.
    Content* targetContent = rootTrie->Find(name);

    //߰  ִ 
    if (targetContent != nullptr)
    {
        //   ִ ¿ Ȯմϴ.
        bool alreadyAvailable = targetContent->AvailableCheck();
        //  ҽŵϴ.
        targetContent->SubNumber(wantNumber);

        //    ִ ¿,  ҷ     Ȳ̶
        //شϴ  Ȯտ  Ȯ ϴ.
        if (alreadyAvailable == true && !targetContent->AvailableCheck())
        {
            if (targetContent->isFlexible)
            {
                rateFlexible -= targetContent->GetRate();
            }
            else
            {
                rateNonFlexible -= targetContent->GetRate();
            };
        };
    };
}

///<summary>ϴ   ϴ  մϴ.</summary>
void RandomBox::SetNumber(string name, unsigned int wantNumber)
{
    //شϴ ̸  ִ Ȯմϴ.
    Content* targetContent = rootTrie->Find(name);

    //߰  ִ 
    if (targetContent != nullptr)
    {
        //   ִ ¿ Ȯմϴ.
        bool alreadyAvailable = targetContent->AvailableCheck();
        //  մϴ.
        targetContent->SetNumber(wantNumber);

        //    ִ ° ƴϾ,  ߰   ְ  Ȳ̶
        //شϴ  Ȯտ  Ȯ մϴ.
        if (alreadyAvailable == false && targetContent->AvailableCheck())
        {
            if (targetContent->isFlexible)
            {
                rateFlexible += targetContent->GetRate();
            }
            else
            {
                rateNonFlexible += targetContent->GetRate();
            };
        }
        //    ִ ¿,  ҷ     Ȳ̶
        //شϴ  Ȯտ  Ȯ ϴ.
        else if (alreadyAvailable == true && !targetContent->AvailableCheck())
        {
            if (targetContent->isFlexible)
            {
                rateFlexible -= targetContent->GetRate();
            }
            else
            {
                rateNonFlexible -= targetContent->GetRate();
            };
        };
    };
}

///<summary>ϴ     ִ մϴ.</summary>
void RandomBox::SetInfinity(string name, bool wantInfinity)
{
    //شϴ ̸  ִ Ȯմϴ.
    Content* targetContent = rootTrie->Find(name);

    //߰  ִ 
    if (targetContent != nullptr)
    {
        //   ִ ¿ Ȯմϴ.
        bool alreadyAvailable = targetContent->AvailableCheck();

        // θ մϴ.
        targetContent->SetInfinity(wantInfinity);

        //    ִ ° ƴϾ,    ְ  Ȳ̶
        //شϴ  Ȯտ  Ȯ մϴ.
        if (alreadyAvailable == false && targetContent->AvailableCheck())
        {
            if (targetContent->isFlexible)
            {
                rateFlexible += targetContent->GetRate();
            }
            else
            {
                rateNonFlexible += targetContent->GetRate();
            };
        }
        //    ִ ¿,      Ȳ̶
        //شϴ  Ȯտ  Ȯ ϴ.
        else if (alreadyAvailable == true && !targetContent->AvailableCheck())
        {
            if (targetContent->isFlexible)
            {
                rateFlexible -= targetContent->GetRate();
            }
            else
            {
                rateNonFlexible -= targetContent->GetRate();
            };
        };
    };
}

///<summary>ϴ  ̸ from to մϴ.</summary>
void RandomBox::SetName(string from, string to)
{
    //شϴ  ִ Ȯմϴ.
    Content* targetContent = rootTrie->Find(from);

    //شϴ  ְ, to شϴ ̸   ٸ
    if (targetContent != nullptr && rootTrie->Find(to) == nullptr)
    {
        //ش  ̸ մϴ.
        targetContent->SetName(to, rootTrie);
    };
}

///<summary>ϴ  Ȯ մϴ.</summary>
void RandomBox::SetRate(string name, float wantRate)
{
    //شϴ  ִ Ȯմϴ.
    Content* targetContent = rootTrie->Find(name);

    //߰  ִ 
    if (targetContent != nullptr)
    {
        //Ȯ  Ŀ,  Ȯ ٽ մϴ.
        if (targetContent->isFlexible)
        {
            rootFlexible = targetContent->SetRate(wantRate, rootFlexible);
            rateFlexible = rootFlexible->GetTotalRate();
        }
        else
        {
            rootNonFlexible = targetContent->SetRate(wantRate, rootNonFlexible);
            rateNonFlexible = rootNonFlexible->GetTotalRate();
        };
    };
}
///<summary>ϴ   ɼ մϴ.</summary>
void RandomBox::SetFlexible(string name, bool wantFlexible)
{
    //شϴ  ִ Ȯմϴ.
    Content* targetContent = rootTrie->Find(name);
    
    //߰  ִ 
    if (targetContent != nullptr)
    {
        //  ɼ Է° ٸ մϴ.
        if (targetContent->isFlexible != wantFlexible)
        {
            // ġ شϴ  ϰ Ȯ ٽ մϴ.
            if (targetContent->isFlexible)
            {
                rootFlexible = targetContent->Delete(rootFlexible);
                rateFlexible = rootFlexible->GetTotalRate();
            }
            else
            {
                rootNonFlexible = targetContent->Delete(rootNonFlexible);
                rateNonFlexible = rootNonFlexible->GetTotalRate();
            };
            
            //ɼ  Ŀ, ο ġ  ߰ϰ Ȯ ٽ մϴ.
            targetContent->isFlexible = wantFlexible;
            if (wantFlexible)
            {
                rootFlexible = targetContent->Insert(rootFlexible);
                rateFlexible = rootFlexible->GetTotalRate();
            }
            else
            {
                rootNonFlexible = targetContent->Insert(rootNonFlexible);
                rateNonFlexible = rootNonFlexible->GetTotalRate();
            };
        };
    };
}

///<summary>ϴ  Ȱȭ θ մϴ.</summary>
void RandomBox::SetAvailable(string name, bool wantAvailable)
{
    //شϴ  ִ Ȯմϴ.
    Content* targetContent = rootTrie->Find(name);

    //߰  ִ 
    if (targetContent != nullptr)
    {
        //   ִ ¿ Ȯմϴ.
        bool beforeAvailable = targetContent->AvailableCheck();

        //Ȱȭ θ Է  մϴ.
        targetContent->isAvailable = wantAvailable;

        //   ִ  Ȯմϴ.
        bool afterAvailable = targetContent->AvailableCheck();

        // ɼ  
        if (beforeAvailable != afterAvailable)
        {
            // ϸ Ȯ ߰, Ұ Ȯ ҽŵϴ.
            if (afterAvailable)
            { 
                if (targetContent->isFlexible)
                {
                    rateFlexible += targetContent->GetRate();
                }
                else
                {
                    rateNonFlexible += targetContent->GetRate();
                };
            }
            else
            {
                if (targetContent->isFlexible)
                {
                    rateFlexible -= targetContent->GetRate();
                }
                else
                {
                    rateNonFlexible -= targetContent->GetRate();
                };
            };
        };
    };
}

///<summary>Ȯ Ȯ    ִ Ȯմϴ.  شϴ ̶,   ̰  ȯմϴ.</summary>
///<param name="rate"> Ȯ ⿡ ֽϴ.</param>
///<param name="multiplier">Ȯ  ϴ Դϴ. ۿ ش  ؼ  Ȯ ϰ մϴ.</param>
Content* Content::RateCheck(float* rateIn, float multiplier)
{
    //̱Ⱑ  쿡 մϴ.
    if (AvailableCheck())
    {
        //Ȯ  մϴ.
        float multiplierRateCurrent = rate * multiplier;

        //  Ȯ   Ȯ ų  , ̶ մϴ.
        if (*rateIn <= multiplierRateCurrent)
        {
            // ƴ 쿡  Դϴ.
            if (!isInfinity)
            {
                --number;
            };
            // Ƚ 1 ߰մϴ.
            ++pickedTime;

            // Ȯ 0̶ ˸ϴ.
            *rateIn = 0.0f;
            
            // ȯմϴ.
            return this;
        }
        // Ȯ   Ȯ ū   忡 Ȯ ûմϴ.
        else
        {
            //ϱ  Ȯ  Ȯ ϴ.
            *rateIn -= multiplierRateCurrent;
            // 尡 ִ 
            if (next != nullptr)
            {
                // Ȯ   Ȯ  忡 մϴ.
                return next->RateCheck(rateIn, multiplier);
            }
            // 尡  
            else
            {
                //  ٰ ˸ϴ.
                return nullptr;
            };
        };
    }
    //̱Ⱑ Ұ 쿡
    else
    {
        // 尡  Է° ״ մϴ.
        if (next != nullptr)
        {
            return next->RateCheck(rateIn, multiplier);
        }
        // 尡   Ȯ ״ ȯϰ,   ٰ ˸ϴ.
        else
        {
            return nullptr;
        };
    };
}

///<summary>  ϴ  ο ֽϴ. ù ° Ҹ ְ ϸ,  ù ° Ҹ ȯմϴ.</summary>
Content* Content::Insert(Content* targetRoot)
{
    //ù ° Ұ ,  ù ° ˸ϴ.
    if (targetRoot == nullptr)
    {
        targetRoot = this;
        return this;
    }
    else
    {
        //ù ° Һ  Ȯ մϴ.
        Content* nextContent = targetRoot;
        while (nextContent != nullptr)
        {
            //Ȯϴ  κ ū Ȯ  ִ 
            if (nextContent->rate > rate)
            {
                //󺸴   Ȯ  
                if (nextContent->next == nullptr)
                {
                    // ڿ  ġŵϴ.
                    nextContent->next = this;
                    prev = nextContent;
                    return targetRoot;
                }
                //󺸴   Ȯ ִ   Ȯ Ȯմϴ.
                else
                {
                    nextContent = nextContent->next;
                };
            }
            //Ȯϴ  κ  Ȯ  ִ 
            else
            {
                //󺸴 ū Ȯ  
                if (nextContent->prev != nullptr)
                {
                    // ̿    ڸ մϴ.
                    prev = nextContent->prev;
                    next = nextContent;

                    //ѿԵ  ٴ  ˸ϴ.
                    nextContent->prev->next = this;
                    nextContent->prev = this;

                    return targetRoot;
                }
                //󺸴 ū Ȯ  
                else
                {
                    // տ ġ ڿ, ù ° Ұ  Ǿٰ ˸ϴ.
                    next = nextContent;
                    nextContent->prev = this;
                    targetRoot = this;
                    return this;
                };
            };
        };
    };
}

/// <summary>ش  ڷ ̵մϴ.</summary>
void Content::MoveAfter(Content* targetContent)
{
    // ִ ġ  ϴ.
    Pop();

    //  带 ϴ.
    next = targetContent->next;
    prev = targetContent;

    //  忡  Ǿ ˸ϴ.
    if (next != nullptr)
    {
        next->prev = this;
    };
    targetContent->next = this;
}

/// <summary>ش   ̵մϴ.</summary>
void Content::MoveBefore(Content* targetContent)
{
    // ִ ġ  ϴ.
    Pop();

    //  带 ϴ.
    prev = targetContent->prev;
    next = targetContent;

    //  忡  Ǿ ˸ϴ.
    if (prev != nullptr)
    {
        prev->next = this;
    };
    targetContent->prev = this;
}

/// <summary> ߰մϴ.</summary>
void Content::AddNumber(unsigned int wantNumber)
{
    //     , uint ִ Ѵ´ٸ ִ մϴ.
    if (UINT_MAX - wantNumber <= number)
    {
        number = UINT_MAX;
    }
    //ƴϸ ׳ մϴ.
    else
    {
        number += wantNumber;
    };
}

/// <summary> ҽŵϴ.</summary>
void Content::SubNumber(unsigned int wantNumber)
{
    //    ū 쿡 0 մϴ.
    if (wantNumber >= number)
    {
        number = 0;
    }
    //ƴϸ ׳ ϴ.
    else
    {
        number -= wantNumber;
    };
}

/// <summary>Ȯ մϴ.</summary>
Content* Content::SetRate(float wantRate, Content* targetRoot)
{
    //Ȯ  ̸ صӴϴ.
    Content* targetContent;

    //Ȯ  Ŀ 
    if (wantRate > rate)
    {
        //Ȯ ϴ ŵϴ.
        rate = wantRate;

        //Ȯ  ڽ ٷ  մϴ.
        targetContent = prev;
        while (targetContent != nullptr)
        {
            //, Ȯ  Ȯ ٲ Ȯ ũٸ,  ڿ ϴ.
            if (targetContent->rate > wantRate)
            {
                MoveAfter(targetContent);
                return targetRoot;
            }
            //Ȯ  Ȯ ٲ Ȯ ۴ٸ
            else
            {
                //׺ ū Ȯ  Ȯϱ   ̵մϴ.
                if (targetContent->prev != nullptr)
                {
                    targetContent = targetContent->prev;
                }
                //׺ ū Ȯ  ,  ̵ϰ   ̶ ˸ϴ.
                else
                {
                    Pop();
                    next = targetContent;
                    prev = nullptr;
                    targetContent->prev = this;
                    targetRoot = this;
                    return this;
                };
            };
        };
    }
    //Ȯ  ۾ 
    else if (wantRate < rate)
    {
        // ù ° ҿٸ
        if (targetRoot == this)
        {
            //ù ° Ҹ    صΰ մϴ.
            targetRoot = next;
        };

        //Ȯ մϴ.
        rate = wantRate;

        //Ȯ    մϴ.
        targetContent = next;
        while (targetContent != nullptr)
        {
            //Ȯ  Ȯ  Ȯ  
            if (targetContent->rate < wantRate)
            {
                //ش  տ ġմϴ.
                MoveBefore(targetContent);

                //ġ ڿ,  庸 ū Ȯ  尡 
                // 尡 ù ° Ҷ ˸ϴ.
                if (prev == nullptr)
                {
                    targetRoot = this;
                    return this;
                }
                //ƴ϶, ƹ ͵  ʽϴ.
                else
                {
                    return targetRoot;
                };
            }
            //Ȯ  Ȯ  Ȯ ū 
            else
            {
                //   Ȯ 尡 ִٸ ش 带 Žմϴ. 
                if (targetContent->next != nullptr)
                {
                    targetContent = targetContent->next;
                }
                //  Ȯ 尡 ٸ,   ġŵϴ.
                else
                {
                    Pop();
                    prev = targetContent;
                    next = nullptr;
                    targetContent->next = this;

                    return targetRoot;
                };
            };
        };
    };
}

/// <summary>  ڿ ̾  Ȯ ݴϴ.</summary>
float Content::GetTotalRate()
{
    // 尡  
    if (next != nullptr)
    {
        // 尡   ִ     Ȯ ϰ, ƴ϶  ʽϴ.
        if (AvailableCheck())
        {
            return next->GetTotalRate() + rate;
        }
        else
        {
            return next->GetTotalRate();
        };

    }
    // 尡 ٸ
    else
    {
        //  ִ  Ȯ Ŀ, Ȯ ȯ 0 ȯ ϴ.
        if (AvailableCheck())
        {
            return rate;
        }
        else
        {
            return 0;
        };
    };
}

/// <summary>ϴ ڰ Ǿִ Ȯմϴ.</summary>
TrieNode* TrieNode::CheckChild(char targetCharacter)
{
    for (int i = 0; i < childList.size(); ++i)
    {
        if (childList[i]->character == targetCharacter)
        {
            return childList[i];
        };
    };

    return nullptr;
}

/// <summary>ش ڿ ڷᱸ ߰մϴ.</summary>
void TrieNode::Insert(string wantString, Content* wantAddress)
{
    //ش ڿ ִ 
    if (wantString.size() > 0)
    {
        //   ߿ ڿ ù ° ڿ   ִ Ȯմϴ.
        TrieNode* nextChild = CheckChild(wantString[0]);

        // ڿٸ  ߰մϴ.
        if (nextChild == nullptr)
        {
            nextChild = new TrieNode(wantString[0]);
            childList.push_back(nextChild);
            nextChild->parent = this;
        };

        //ڿ    , ؿ  ߰ش޶ ûմϴ.
        return nextChild->Insert(wantString.substr(1,wantString.size() - 1), wantAddress);
    }
    // ڰ  
    else
    {
        // ּҸ  ġ մϴ.
        wantAddress->inTrie = this;
        address = wantAddress;
    };
}

/// <summary>ش ڷᱸ   иŵϴ.</summary>
void TrieNode::Destroy()
{
    //۰  մϴ.
    if (address != nullptr)
    {
        if (address->inTrie == this)
        {
            address->inTrie = nullptr;
        };
        address = nullptr;
    };

    //  ġ и ûմϴ.
    for (int i = 0; i < childList.size(); ++i)
    {
        childList[i]->Destroy();
    };
    //   ġ մϴ.
    childList.clear();
}

/// <summary>ش ڿ ڷᱸ մϴ.</summary>
void TrieNode::Delete()
{
    //۰  մϴ.
    if (address != nullptr)
    {
        if (address->inTrie == this)
        {
            address->inTrie = nullptr;
        };
        address = nullptr;
    };

    // ġ  ϴ̹Ƿ ٷ  մϴ.
    if (childList.size() <= 0)
    {
        // ġ  Źϱ ؼ  ġ Ȯմϴ.
        if (parent != nullptr)
        {
            // ġ  尡 ,  ҵ  ʴ´ٸ  ڿ   ġ  Բ մϴ.
            if (parent->address == nullptr && parent->childList.size() <= 1)
            {
                parent->childList.clear();
                parent->Delete();
            }
            // ǿ  ʴ´ٸ,  ġ մϴ.
            else
            {
                for (int i = 0; i < parent->childList.size(); ++i)
                {
                    if (parent->childList[i] == this)
                    {
                        parent->childList.erase(parent->childList.begin() + i);
                    };
                };
            };
        };
    };

    free(this);
}

/// <summary>ڿ ޾Ƽ شϴ ġ ãϴ.</summary>
Content* TrieNode::Find(string wantString)
{
    //ã ڰ  
    if (wantString.size() > 0)
    {
        // ġ ش ڰ ִ Ȯմϴ.
        TrieNode* nextChild = CheckChild(wantString[0]);

        // ̾ ã   ġ  ڿ Ѱݴϴ.
        if (nextChild != nullptr)
        {
            return nextChild->Find(wantString.substr(1,wantString.size() - 1));
        }
        // ڰ  ,    nullptr ȯմϴ.
        else
        {
            return nullptr;
        };
    }
    // ̻ ã ڰ ,  ġ Ű  ȯմϴ.
    else
    {
        return address;
    };
}